Index: issm/trunk/src/m/plot/processdata.py
===================================================================
--- issm/trunk/src/m/plot/processdata.py	(revision 25994)
+++ issm/trunk/src/m/plot/processdata.py	(revision 26744)
@@ -15,5 +15,5 @@
     See also: PLOTMODEL, PROCESSMESH
     """
-    # {{{ Initialization and grabbing auxiliaries
+    # Initialization and grabbing auxiliaries {{{
     # check format
     if (len(data) == 0 or (len(data) == 1 and not isinstance(data, dict) and np.isnan(data).all())):
@@ -22,8 +22,15 @@
     if 'numberofvertices2d' in dir(md.mesh):
         numberofvertices2d = md.mesh.numberofvertices2d
-        numberofelements2d = md.mesh.numberofelements2d
     else:
         numberofvertices2d = np.nan
-        numberofelements2d = np.nan
+
+    if options.exist('amr'):
+        step = options.getfieldvalue('amr', 0)
+        numberofvertices = len(md.results.TransientSolution[step].MeshX)
+        numberofelements = np.shape(md.results.TransientSolution[step].MeshElements)[0]
+    else:
+        numberofvertices = md.mesh.numberofvertices
+        numberofelements = md.mesh.numberofelements
+
     procdata = np.copy(data)
     #initialize datatype
@@ -44,5 +51,93 @@
         raise ValueError('data passed to plotmodel has bad dimensions; check that column vectors are rank - 1')
     # }}}
-    # {{{ process NaN's if any
+
+    #  log {{{
+    if options.exist('log'):
+        cutoff = options.getfieldvalue('log', 1)
+        procdata[np.where(procdata < cutoff)] = cutoff
+    # }}}
+
+    #  quiver plot {{{
+    if datasize[1] > 1 and datasize[0] != numberofvertices + 1:
+        if datasize[0] == numberofvertices and datasize[1] == 2:
+            datatype = 3
+        else:
+            raise ValueError('plotmodel error message: data should have two columns of length md.mesh.numberofvertices for a quiver plot')
+    # }}}
+
+    #  element data{{{
+    if datasize[0] == numberofelements and datasize[1] == 1:
+        #initialize datatype if non patch
+        if datatype != 4 and datatype != 5:
+            datatype = 1
+        # AMR {{{
+        if options.exist('amr'):
+            nonan = np.nonzero(~np.isnan(md.results.TransientSolution[step].MeshElements))
+            procdata = procdata[nonan]
+        # }}}
+        # mask {{{
+        if options.exist('mask'):
+            flags = options.getfieldvalue('mask')
+            hide = np.invert(flags)
+            if np.size(flags) == numberofvertices:
+                EltMask = np.asarray([np.any(np.in1d(index, np.where(hide))) for index in md.mesh.elements - 1])
+                procdata = np.ma.array(procdata, mask=EltMask)
+                options.addfielddefault('cmap_set_bad', 'w')
+            elif np.size(flags) == numberofelements:
+                procdata = np.ma.array(procdata, mask=hide)
+                options.addfielddefault('cmap_set_bad', 'w')
+            else:
+                print('Warning: processdata.py: mask length not supported yet (supported length are md.mesh.numberofvertices and md.mesh.numberofelements')
+        # }}}
+
+    # }}}
+
+    #  node data {{{
+    if datasize[0] in [numberofvertices, numberofvertices2d] and datasize[1] == 1:
+        datatype = 2
+        # AMR {{{
+        if options.exist('amr'):
+            nonan = np.nonzero(~np.isnan(md.results.TransientSolution[step].MeshX))
+            procdata = procdata[nonan]
+        # }}}
+        #  Mask {{{
+        if options.exist('mask'):
+            flags = options.getfieldvalue('mask')
+            hide = np.invert(flags)
+            if np.size(flags) == numberofvertices:
+                procdata = np.ma.array(procdata, mask=hide)
+                options.addfielddefault('cmap_set_bad', 'w')
+            elif np.size(flags) == numberofelements:
+                NodeMask = np.zeros(np.shape(md.mesh.x), dtype=bool)
+                HideElt = md.mesh.elements[np.where(hide)[0]] - 1
+                NodeMask[HideElt] = True
+                procdata = np.ma.array(procdata, mask=NodeMask)
+                options.addfielddefault('cmap_set_bad', 'w')
+            else:
+                print('Warning: processdata.py: mask length not supported yet (supported length are md.mesh.numberofvertices and md.mesh.numberofelements')
+        # }}}
+    # }}}
+
+    #  spc time series {{{
+    if datasize[0] == numberofvertices + 1:
+        datatype = 2
+        spccol = options.getfieldvalue('spccol', 0)
+        print('multiple-column spc field; specify column to plot using option "spccol"')
+        print(('column ', spccol, ' plotted for time: ', procdata[-1, spccol]))
+        procdata = procdata[0:-1, spccol]
+
+        #mask?
+
+        #layer projection?
+
+        #control arrow density if quiver plot
+    # }}}
+
+    # convert rank - 2 array to rank - 1 {{{
+    if np.ndim(procdata) == 2 and np.shape(procdata)[1] == 1:
+        procdata = procdata.reshape(-1, )
+    # }}}
+
+    #  process NaN's if any {{{
     nanfill = options.getfieldvalue('nan', -9999)
     if np.any(np.isnan(procdata)):
@@ -53,83 +148,13 @@
             ub = ub + 0.5
             nanfill = lb - 1
-    #procdata[np.isnan(procdata)] = nanfill
+        procdata[np.isnan(procdata)] = nanfill
         procdata = np.ma.array(procdata, mask=np.isnan(procdata))
-        options.addfielddefault('clim', [lb, ub])
+        #clim looks to be deprecated and replaced by caxis
+        #options.addfielddefault('clim', [lb, ub])
         options.addfielddefault('cmap_set_under', '1')
         print(("WARNING: nan's treated as", nanfill, "by default.  Change using pairoption 'nan', nan_fill_value in plotmodel call"))
     # }}}
-    # {{{ log
-    if options.exist('log'):
-        cutoff = options.getfieldvalue('log', 1)
-        procdata[np.where(procdata < cutoff)] = cutoff
-    # }}}
-    # {{{ quiver plot
-    if datasize[1] > 1 and datasize[0] != md.mesh.numberofvertices + 1:
-        if datasize[0] == md.mesh.numberofvertices and datasize[1] == 2:
-            datatype = 3
-        else:
-            raise ValueError('plotmodel error message: data should have two columns of length md.mesh.numberofvertices for a quiver plot')
-    # }}}
-    # {{{ element data
 
-    if datasize[0] == md.mesh.numberofelements and datasize[1] == 1:
-        #initialize datatype if non patch
-        if datatype != 4 and datatype != 5:
-            datatype = 1
-    # {{{mask
-        if options.exist('mask'):
-            flags = options.getfieldvalue('mask')
-            hide = np.invert(flags)
-            if np.size(flags) == md.mesh.numberofvertices:
-                EltMask = np.asarray([np.any(np.in1d(index, np.where(hide))) for index in md.mesh.elements - 1])
-                procdata = np.ma.array(procdata, mask=EltMask)
-                options.addfielddefault('cmap_set_bad', 'w')
-            elif np.size(flags) == md.mesh.numberofelements:
-                procdata = np.ma.array(procdata, mask=hide)
-                options.addfielddefault('cmap_set_bad', 'w')
-            else:
-                print('plotmodel warning: mask length not supported yet (supported length are md.mesh.numberofvertices and md.mesh.numberofelements')
-    # }}}
-
-    # }}}
-    # {{{ node data
-    if datasize[0] == md.mesh.numberofvertices and datasize[1] == 1:
-        datatype = 2
-    # {{{ Mask
-        if options.exist('mask'):
-            flags = options.getfieldvalue('mask')
-            hide = np.invert(flags)
-            if np.size(flags) == md.mesh.numberofvertices:
-                procdata = np.ma.array(procdata, mask=hide)
-                options.addfielddefault('cmap_set_bad', 'w')
-            elif np.size(flags) == md.mesh.numberofelements:
-                NodeMask = np.zeros(np.shape(md.mesh.x), dtype=bool)
-                HideElt = md.mesh.elements[np.where(hide)[0]] - 1
-                NodeMask[HideElt] = True
-                procdata = np.ma.array(procdata, mask=NodeMask)
-                options.addfielddefault('cmap_set_bad', 'w')
-            else:
-                print('plotmodel warning: mask length not supported yet (supported length are md.mesh.numberofvertices and md.mesh.numberofelements')
-    # }}}
-    # }}}
-    # {{{ spc time series
-    if datasize[0] == md.mesh.numberofvertices + 1:
-        datatype = 2
-        spccol = options.getfieldvalue('spccol', 0)
-        print('multiple-column spc field; specify column to plot using option "spccol"')
-        print(('column ', spccol, ' plotted for time: ', procdata[-1, spccol]))
-        procdata = procdata[0:-1, spccol]
-
-    #mask?
-
-    #layer projection?
-
-    #control arrow density if quiver plot
-    # }}}
-    # {{{ convert rank - 2 array to rank - 1
-    if np.ndim(procdata) == 2 and np.shape(procdata)[1] == 1:
-        procdata = procdata.reshape(-1, )
-    # }}}
-    # {{{ if datatype is still zero, error out
+    #  if datatype is still zero, error out {{{
     if datatype == 0:
         raise ValueError("processdata error: data provided not recognized or not supported")
Index: issm/trunk/src/m/plot/processmesh.py
===================================================================
--- issm/trunk/src/m/plot/processmesh.py	(revision 25994)
+++ issm/trunk/src/m/plot/processmesh.py	(revision 26744)
@@ -41,12 +41,22 @@
     if hasattr(md.mesh, 'elements2d'):
         elements2d = md.mesh.elements2d
+        numofvertices2d = md.mesh.numberofvertices2d
+        numofelements2d = md.mesh.numberofelements2d
+    else:
+        numofvertices2d = np.nan
+        numofelements2d = np.nan
 
     if options.exist('amr'):
         step = options.getfieldvalue('amr')
-        x = md.results.TransientSolution[step].MeshX
-        y = md.results.TransientSolution[step].MeshY
-        elements = md.results.TransientSolution[step].MeshElements
+        nonan = np.nonzero(~np.isnan(md.results.TransientSolution[step].MeshX))
+        x = md.results.TransientSolution[step].MeshX[nonan]
+        y = md.results.TransientSolution[step].MeshY[nonan]
+        nonan = np.nonzero(~np.isnan(md.results.TransientSolution[step].MeshElements))
+        elements = md.results.TransientSolution[step].MeshElements[nonan] - 1
+        eldim = np.shape(md.results.TransientSolution[step].MeshElements)[1]
+        elements = np.reshape(elements, ((int(len(elements) / eldim), eldim)))
+
     else:
-        elements = md.mesh.elements
+        elements = md.mesh.elements - 1
         if options.getfieldvalue('coord', 'xy') != 'latlon':
             x = md.mesh.x
@@ -65,14 +75,13 @@
         z = getattr(md, z)
 
+    force2D = numofelements2d in np.shape(data) or numofvertices2d in np.shape(data)
     #is it a 2D plot?
-    if md.mesh.dimension() == 2 or options.getfieldvalue('layer', 0) >= 1:
+    if md.mesh.dimension() == 2 or options.getfieldvalue('layer', 0) >= 1 or force2D:
         is2d = 1
     else:
         is2d = 0
 
-    elements = md.mesh.elements - 1
-
     #layer projection?
-    if options.getfieldvalue('layer', 0) >= 1:
+    if options.getfieldvalue('layer', 0) >= 1 or force2D:
         if options.getfieldvalue('coord', 'xy') == 'latlon':
             raise Exception('processmesh error message: cannot work with 3D meshes for now')
Index: issm/trunk/src/m/plot/radarpower.m
===================================================================
--- issm/trunk/src/m/plot/radarpower.m	(revision 25994)
+++ issm/trunk/src/m/plot/radarpower.m	(revision 26744)
@@ -29,5 +29,5 @@
 d = getfieldvalue(options,'overlay_adjust_d',1);
 
-%find gdal coordinates
+%find GDAL coordinates
 x0=min(xlim); x1=max(xlim);
 y0=min(ylim); y1=max(ylim);
@@ -38,13 +38,30 @@
 	elseif md.mesh.epsg==3031, %Antarctica
 			if highres,
-				paths = {'/Users/larour/ModelData/MosaicTiffRsat/amm125m_v2_200m.tif','/home/ModelData/Antarctica/MosaicTiffRsat/amm125m_v2_200m.tif'};
+				paths = {'/Users/larour/ModelData/MosaicTiffRsat/amm125m_v2_200m.tif',...
+					'/home/ModelData/Antarctica/MosaicTiffRsat/amm125m_v2_200m.tif',...
+					'/totten_1/ModelData/Antarctica/MosaicTiffRsat/amm125m_v2_200m.tif',...
+					'./amm125m_v2_200m.tif',...
+					};
 			else
-				paths = {'/Users/larour/ModelData/MosaicTiffRsat/amm125m_v2_1km.tif','/home/ModelData/Antarctica/MosaicTiffRsat/amm125m_v2_1km.tif'};
+				paths = {'/Users/larour/ModelData/MosaicTiffRsat/amm125m_v2_1km.tif',...
+					'/home/ModelData/Antarctica/MosaicTiffRsat/amm125m_v2_1km.tif',...
+					'/totten_1/ModelData/Antarctica/MosaicTiffRsat/amm125m_v2_1km.tif',...
+					'./amm125m_v2_1km.tif',...
+					};
 			end
 	elseif md.mesh.epsg==3413,   %Greenland 
 		if highres,
-			paths = {'/u/astrid-r1b/ModelData/MOG/mog100_r2_hp1.tif','/home/ModelData/Greenland/MOG/mog100_r2_hp1.tif'};
+			paths = {'/u/astrid-r1b/ModelData/MOG/mog100_r2_hp1.tif',...
+				'/home/ModelData/Greenland/MOG/mog100_r2_hp1.tif',...
+				'/totten_1/ModelData/Greenland/MOG/mog100_r2_hp1.tif',...
+				'./mog100_r2_hp1.tif',...
+				};
 		else
-			paths = {'/u/astrid-r1b/ModelData/MOG/mog500_r2_hp1.tif','/home/ModelData/Greenland/MOG/mog500_r2_hp1.tif'};
+			paths = {'/u/astrid-r1b/ModelData/MOG/mog500_r2_hp1.tif',...
+				'/home/ModelData/Greenland/MOG/mog500_r2_hp1.tif',...
+				'/totten_1/ModelData/Greenland/MOG/mog500_r2_hp1.tif',...
+				'/Users/larour/ModelData/MOG/mog500_r2_hp1.tif',...
+				'./mog500_r2_hp1.tif',...
+				};
 		end
 	else
Index: issm/trunk/src/m/plot/radarpower.py
===================================================================
--- issm/trunk/src/m/plot/radarpower.py	(revision 26744)
+++ issm/trunk/src/m/plot/radarpower.py	(revision 26744)
@@ -0,0 +1,16 @@
+def solveslm(slm, solutionstringi, *args):
+    """RADARPOWER - overlay a power radar image on an existing mesh
+
+    This routine will overlay a power radar image on an existing mesh.
+    The power amplitude will be output to vel for now.
+    In the future, think about a field to hold this value.
+
+    Usage:
+        md=radarpower(md,options);
+        md=radarpower(md)
+
+    TODO:
+    - Translate from MATLAB API as we bring Python plotting capabilities online
+    """
+
+    return md
Index: issm/trunk/src/m/plot/subplotmodel.m
===================================================================
--- issm/trunk/src/m/plot/subplotmodel.m	(revision 25994)
+++ issm/trunk/src/m/plot/subplotmodel.m	(revision 26744)
@@ -4,4 +4,20 @@
 %   Usage:
 %      h=subplotmodel(nlines,ncols,i,options)
+
+box=getfieldvalue(options,'box','off');
+if strcmpi(box,'on'),
+	visible='on';
+else
+	visible='off';
+end
+
+%Do we specify axes?
+if exist(options,'axes')
+	ax = getfieldvalue(options,'axes');
+	ha = axes('Units','normalized', ...
+		'Position',ax,'XTickLabel','','YTickLabel','',...
+		'Visible',visible,'box',box);
+	return
+end
 
 %Regular subplot
@@ -25,11 +41,4 @@
 ymin   = 1-vmargin(2)-height; 
 
-box=getfieldvalue(options,'box','off');
-if strcmpi(box,'on'),
-	visible='on';
-else
-	visible='off';
-end
-
 for i = 1:nlines
 	xmin = hmargin(1);
Index: issm/trunk/src/m/shp/shp2exp.m
===================================================================
--- issm/trunk/src/m/shp/shp2exp.m	(revision 25994)
+++ issm/trunk/src/m/shp/shp2exp.m	(revision 26744)
@@ -1,4 +1,4 @@
 function shp2exp(shpfilename,expfilename)
-%SHP2EXP- transform shape file to Argus .exp file
+%SHP2EXP - transform shape file to Argus .exp file
 %
 %   Usage:
@@ -48,17 +48,28 @@
 	elseif strcmpi(shp(i).Geometry,'Point'),
 		x=shp(i).X; y=shp(i).Y;
-		expstruct(end+1).x=x;
-		expstruct(end).y=y;
-		expstruct(end).nods=length(x);
-		expstruct(end).density=1;
-		expstruct(end).closed=0;
-		%exp(end).name=num2str(shp(i).id);
+		if ~isnan(x) && ~isnan(y)
+			expstruct(end+1).x=x;
+			expstruct(end).y=y;
+			expstruct(end).nods=length(x);
+			expstruct(end).density=1;
+			expstruct(end).closed=0;
+			%exp(end).name=num2str(shp(i).id);
+		end
+	elseif strcmpi(shp(i).Geometry,'PointZ'),
+		shp(i)
 	elseif strcmpi(shp(i).Geometry,'Line'),
-		x=shp(i).X; y=shp(i).Y;
-		expstruct(end+1).x=x;
-		expstruct(end).y=y;
-		expstruct(end).nods=length(x);
-		expstruct(end).density=1;
-		expstruct(end).closed=0;
+		x=shp(i).X(:); y=shp(i).Y(:);
+		pos = find(~isnan(x) & ~isnan(y));
+		idx=find(diff(pos)~=1);
+		A=[idx(1);diff(idx);numel(pos)-idx(end)];
+		Cx=mat2cell(x(pos),A,1);
+		Cy=mat2cell(y(pos),A,1);
+		for i=1:numel(Cx)
+			expstruct(end+1).x=Cx{i};
+			expstruct(end).y=Cy{i};
+			expstruct(end).nods=length(Cx{i});
+			expstruct(end).density=1;
+			expstruct(end).closed=0;
+		end
 	end
 end
Index: issm/trunk/src/m/shp/shp2exp.py
===================================================================
--- issm/trunk/src/m/shp/shp2exp.py	(revision 25994)
+++ issm/trunk/src/m/shp/shp2exp.py	(revision 26744)
@@ -1,12 +1,12 @@
+import os
 import shapefile
-import os
 from expwrite import expwrite
 
 
-def shp2exp(shapefilename, * expfilename):
-    '''
-    Convert a shapefile to an .exp file.  Optionally, expfilename can be
-    specified to give a name for the .exp file to be created, otherwise the
-    .exp file will have the same prefix as the .shp file.
+def shp2exp(shapefilename, *expfilename):
+    """SHP2EXP - Convert a shapefile to an Argus .exp file. Optionally, 
+    expfilename can be specified to give a name for the .exp file to be 
+    created, otherwise the .exp file will have the same prefix as the .shp 
+    file.
 
     Usage:
@@ -15,10 +15,12 @@
 
     Examples:
-        shp2exp('Domain.shp') % creates Domain.exp
-        shp2exp('Domain.shp', 'DomainForISSM.exp')
-    '''
+        shp2exp('Domain.shp') # Creates Domain.exp
+        shp2exp('Domain.shp', 'Domain.exp')
+
+    See also EXPMASTER, EXPDOC
+    """
 
     if not os.path.exists(shapefilename):
-        raise IOError("shp2exp error message: file '%s' not found!" % shapefilename)
+        raise IOError('shp2exp error message: file {} not found!'.format(shapefilename))
     if not len(expfilename):
         expfile = os.path.splitext(shapefilename)[0] + '.exp'
@@ -33,5 +35,5 @@
     for i in range(len(shp.shapes())):
         geom = shp.shapes()[i].shapeType
-        if geom == 5:  # polygon
+        if geom == 5: # polygon
             expdict['closed'] = 1
             tmpx = [p[0] for p in shp.shapes()[i].points]
@@ -39,5 +41,5 @@
             x.append(tmpx)
             y.append(tmpy)
-        elif geom == 3:  # line
+        elif geom == 3: # line
             expdict['closed'] = 0
             tmpx = [p[0] for p in shp.shapes()[i].points]
@@ -45,5 +47,5 @@
             x.append(tmpx)
             y.append(tmpy)
-        elif geom == 1:  # point
+        elif geom == 1: # point
             expdict['closed'] = 0
             x.append(shp.shapes()[i].points[0][0])
Index: issm/trunk/src/m/solve/WriteData.js
===================================================================
--- issm/trunk/src/m/solve/WriteData.js	(revision 25994)
+++ issm/trunk/src/m/solve/WriteData.js	(revision 26744)
@@ -1,3 +1,3 @@
-function WriteData(fid,prefix){
+function WriteData(fid,prefix){ //{{{
 //WRITEDATA - write model field into binary buffer 
 //
@@ -74,4 +74,9 @@
 	}
 
+	let recordlengthtype = 'int';
+	if (svnversion >= 22708) {
+		recordlengthtype = 'long long';
+	}
+
 	//Step 1: write the name to identify this record uniquely
 	fid.fwrite(name.length,'int'); 
@@ -83,5 +88,5 @@
 
 		//first write length of record
-		fid.fwrite(4+4,'int');  //1 bool (disguised as an int)+code
+		fid.fwrite(4+4,recordlengthtype);  //1 bool (disguised as an int)+code
 
 		//write data code: 
@@ -95,5 +100,5 @@
 
 		//first write length of record
-		fid.fwrite(4+4,'int');  //1 integer + code
+		fid.fwrite(4+4,recordlengthtype);  //1 integer + code
 
 		//write data code: 
@@ -107,5 +112,5 @@
 
 		//first write length of record
-		fid.fwrite(8+4,'int');  //1 double+code
+		fid.fwrite(8+4,recordlengthtype);  //1 double+code
 
 		//write data code: 
@@ -117,5 +122,5 @@
 	else if (format == 'String'){ // {{{
 		//first write length of record
-		fid.fwrite(data.length+4+4,'int');  //string + string size + code
+		fid.fwrite(data.length+4+4,recordlengthtype);  //string + string size + code
 
 		//write data code: 
@@ -128,18 +133,24 @@
 	else if (format == 'BooleanMat'){ // {{{
 
-		//Get size
-		var s=[data.length,1];
-		if(IsArray(data[0]))s[1]=data[0].length;
+		//Get size (TODO: use into matlab.js::size)
+		var s=[data.length,1]; //vector
+		if (IsArray(data[0])) { //matrix
+			s[1]=data[0].length;
+        } else if (typeof data == 'number') { //scalar
+        	s[0]=1; s[1]=1
+        } else if (data.length == 0) { //empty matrix/vector
+            s[1]=0;
+        }
 
 		//if matrix = NaN, then do not write anything
-		if (s[0]==1 & s[1]==1 & isNaN(data)){
-			s[0]=0; s[1]=0;
-		}
-		if (s[0]==1 & s[1]==1 & isNaN(data[0])){
-			s[0]=0; s[1]=0;
-		}
-
-		//first write length of record
-		fid.fwrite(4+4+8*s[0]*s[1]+4+4,'int');  //2 integers (32 bits) + the double matrix + code + matrix type
+		if (s[0]==1 && s[1]==1 && isNaN(data)){
+			s[0]=0; s[1]=0;
+		}
+		if (typeof data != 'number' && s[0]==1 && s[1]==1 && isNaN(data[0])){
+			s[0]=0; s[1]=0;
+		}
+
+		//first write length of record
+		fid.fwrite(4+4+8*s[0]*s[1]+4+4,recordlengthtype);  //2 integers (32 bits) + the double matrix + code + matrix type
 
 		//write data code and matrix type: 
@@ -154,18 +165,24 @@
 	else if (format == 'IntMat'){ // {{{
 
-		//Get size
-		var s=[data.length,1];
-		if(IsArray(data[0]))s[1]=data[0].length;
+		//Get size (TODO: use into matlab.js::size)
+		var s=[data.length,1]; //vector
+		if (IsArray(data[0])) { //matrix
+			s[1]=data[0].length;
+        } else if (typeof data == 'number') { //scalar
+        	s[0]=1; s[1]=1
+        } else if (data.length == 0) { //empty matrix/vector
+            s[1]=0;
+        }
 
 		//if matrix = NaN, then do not write anything
-		if (s[0]==1 & s[1]==1 & isNaN(data)){
-			s[0]=0; s[1]=0;
-		}
-		if (s[0]==1 & s[1]==1 & isNaN(data[0])){
-			s[0]=0; s[1]=0;
-		}
-
-		//first write length of record
-		fid.fwrite(4+4+8*s[0]*s[1]+4+4,'int');  //2 integers (32 bits) + the double matrix + code + matrix type
+		if (s[0]==1 && s[1]==1 && isNaN(data)){
+			s[0]=0; s[1]=0;
+		}
+		if (typeof data != 'number' && s[0]==1 && s[1]==1 && isNaN(data[0])){
+			s[0]=0; s[1]=0;
+		}
+
+		//first write length of record
+		fid.fwrite(4+4+8*s[0]*s[1]+4+4,recordlengthtype);  //2 integers (32 bits) + the double matrix + code + matrix type
 
 		//write data code and matrix type: 
@@ -181,14 +198,19 @@
 	else if (format == 'DoubleMat'){ // {{{
 
-		//Get size
-		var s=[data.length,1];
-		if(IsArray(data[0]))s[1]=data[0].length;
-		if(typeof data == 'number'){s[0]=1; s[1]=1}
-
+		//Get size (TODO: use into matlab.js::size)
+		var s=[data.length,1]; //vector
+		if (IsArray(data[0])) { //matrix
+			s[1]=data[0].length;
+        } else if (typeof data == 'number') { //scalar
+        	s[0]=1; s[1]=1
+        } else if (data.length == 0) { //empty matrix/vector
+            s[1]=0;
+        }
+        
 		//if matrix = NaN, then do not write anything
-		if (s[0]==1 & s[1]==1 & isNaN(data)){
-			s[0]=0; s[1]=0;
-		}
-		if (s[0]==1 & s[1]==1 & isNaN(data[0])){
+		if (s[0]==1 && s[1]==1 && isNaN(data)){
+			s[0]=0; s[1]=0;
+		}
+		if (typeof data != 'number' && s[0]==1 && s[1]==1 && isNaN(data[0])){
 			s[0]=0; s[1]=0;
 		}
@@ -197,5 +219,5 @@
 		var recordlength=4+4+8*s[0]*s[1]+4+4; //2 integers (32 bits) + the double matrix + code + matrix type
 		if (recordlength>Math.pow(2,31)) throw Error(sprintf("field '%s' cannot be marshalled because it is larger than 2^31 bytes!",name));
-		fid.fwrite(recordlength,'int');
+		fid.fwrite(recordlength,recordlengthtype);
 
 		//write data code and matrix type: 
@@ -224,5 +246,5 @@
 
 		//write length of record
-		fid.fwrite(recordlength,'int'); 
+		fid.fwrite(recordlength,recordlengthtype); 
 
 		//write data code: 
@@ -247,5 +269,5 @@
 		//first get length of string array: 
 		num=data.length;
-		if ((typeof data[0] == 'numeric') & num==1 & isNaN(data[0])){
+		if ((typeof data[0] == 'number') & num==1 & isNaN(data[0])){
 			num = 0;
 		}
@@ -259,5 +281,5 @@
 
 		//write length of record
-		fid.fwrite(recordlength,'int'); 
+		fid.fwrite(recordlength,recordlengthtype); 
 
 		//write data code: 
@@ -278,6 +300,5 @@
 					format.toString(),name));
 	}
-}
-
+} //}}}
 function FormatToCode(format){ // {{{
 	//This routine takes the format string, and hardcodes it into an integer, which 
Index: issm/trunk/src/m/solve/WriteData.py
===================================================================
--- issm/trunk/src/m/solve/WriteData.py	(revision 25994)
+++ issm/trunk/src/m/solve/WriteData.py	(revision 26744)
@@ -67,5 +67,10 @@
                 #We scale everything but the last line that holds time
                 data[:-1, :] = scale * data[:-1, :]
-            else:
+            elif type(data) is list: # Deal with "TypeError: can't multiply sequence by non-int of type 'float'" for type list
+                scaleddata = []
+                for i in range(len(data)):
+                    scaleddata.append(scale * data[i])
+                data = scaleddata
+            else: #
                 data = scale * data
         if np.ndim(data) > 1 and data.shape[0] == timeserieslength:
Index: issm/trunk/src/m/solve/loadresultfromdisk.m
===================================================================
--- issm/trunk/src/m/solve/loadresultfromdisk.m	(revision 25994)
+++ issm/trunk/src/m/solve/loadresultfromdisk.m	(revision 26744)
@@ -49,4 +49,9 @@
 					N=fread(fid,1,'int');
 					field=fread(fid,[N M],'int')';
+				elseif type==5,
+					N=fread(fid,1,'int');
+					fieldr=fread(fid,[N M],'double')';
+					fieldi=fread(fid,[N M],'double')';
+					field=complex(fieldr,fieldi);
 				else
 					error(['cannot read data of type ' num2str(type) ]);
Index: issm/trunk/src/m/solve/loadresultfromdisk.py
===================================================================
--- issm/trunk/src/m/solve/loadresultfromdisk.py	(revision 25994)
+++ issm/trunk/src/m/solve/loadresultfromdisk.py	(revision 26744)
@@ -4,16 +4,14 @@
 
 def loadresultfromdisk(filename, step, name, *args):  # {{{
-    """
-    LOADRESULTFROMDISK - load specific result of solution sequence from disk
+    """LOADRESULTFROMDISK - load specific result of solution sequence from disk
     file "filename"
 
-        Usage:
-            variable = loadresultsfromdisk(filename, step, name)
+    Usage:
+        variable = loadresultsfromdisk(filename, step, name)
 
-        TODO:
-        - Test this module against output of src/m/solve/loadresultsfromdisk.m
+    TODO:
+    - Test this module against output of src/m/solve/loadresultsfromdisk.m
     """
-    print('Got hwrwefew')
-    exit()
+
     # Open file
     try:
@@ -59,4 +57,17 @@
                 for i in range(M):
                     field[i, :] = struct.unpack('{}i'.format(N), fid.read(N * struct.calcsize('i')))
+            elif datatype == 5:
+                # TODO:
+                # - Check that the following results in the same output as 
+                # MATLAB
+                #
+                N = struct.unpack('i', fid.read(struct.calcsize('i')))[0]
+                fieldr = np.zeros(shape=(M, N), dtype=float)
+                fieldi = np.zeros(shape=(M, N), dtype=float)
+                for i in range(M):
+                    fieldr[i, :] = struct.unpack('{}d'.format(N), fid.read(N * struct.calcsize('d')))
+                    fieldi[i, :] = struct.unpack('{}d'.format(N), fid.read(N * struct.calcsize('d')))
+                field = np.vectorize(complex)(fieldr, fieldi)
+                print(field)
             else:
                 raise TypeError("cannot read data of type {}".format(datatype))
Index: issm/trunk/src/m/solve/loadresultsfromcluster.m
===================================================================
--- issm/trunk/src/m/solve/loadresultsfromcluster.m	(revision 25994)
+++ issm/trunk/src/m/solve/loadresultsfromcluster.m	(revision 26744)
@@ -4,7 +4,9 @@
 %   Usage:
 %      md=loadresultsfromcluster(md,varargin);
-%      options include:
-%         - runtimename
-%         - nolog.
+%
+%      Options include: 'runtimename', 'nolog'
+%
+%   Example:
+%     md=loadresultsfromcluster(md,'runtimename','test101-06-15-2021-13-24-18-4883');
 
 %process options: 
Index: issm/trunk/src/m/solve/loadresultsfromcluster.py
===================================================================
--- issm/trunk/src/m/solve/loadresultsfromcluster.py	(revision 25994)
+++ issm/trunk/src/m/solve/loadresultsfromcluster.py	(revision 26744)
@@ -1,19 +1,20 @@
 import os
-import socket
+import subprocess
 
 from helpers import *
 from loadresultsfromdisk import loadresultsfromdisk
-from MatlabFuncs import ispc
+from MatlabFuncs import *
 from pairoptions import pairoptions
 
 
-def remove(filename):
+def remove(filename):  #{{{
     try:
         os.remove(filename)
     except OSError:
         print(('WARNING: ' + filename + ' does not exist'))
+# }}}
 
 
-def loadresultsfromcluster(md, *args):
+def loadresultsfromcluster(md, *args):  #{{{
     """LOADRESULTSFROMCLUSTER - load results of solution sequence from cluster
 
@@ -21,4 +22,9 @@
         md = loadresultsfromcluster(md)
         md = loadresultsfromcluster(md, 'runtimename', runtimename)
+
+        Options include: 'runtimename', 'nolog'
+
+    Example:
+        md = loadresultsfromcluster(md, 'runtimename', 'test101-06-15-2021-13-24-18-4883')
     """
 
@@ -63,5 +69,5 @@
 
     # Erase input file if run was carried out on same platform
-    hostname = socket.gethostname()
+    hostname = oshostname()
     if hostname == cluster.name:
         remove(md.miscellaneous.name + '.bin')
@@ -75,2 +81,3 @@
 
     return md
+# }}}
Index: issm/trunk/src/m/solve/loadresultsfromdisk.py
===================================================================
--- issm/trunk/src/m/solve/loadresultsfromdisk.py	(revision 25994)
+++ issm/trunk/src/m/solve/loadresultsfromdisk.py	(revision 26744)
@@ -16,5 +16,5 @@
     # Check number of inputs/outputs
     if not md or not filename:
-        raise ValueError("loadresultsfromdisk: error message.")
+        raise ValueError('loadresultsfromdisk: error message.')
 
     if not md.qmu.isdakota:
@@ -31,5 +31,5 @@
             return
 
-        # Initialize md.results if not a structure yet
+        # Initialize md.results if it is not a structure yet
         if not isinstance(md.results, results):
             md.results = results()
@@ -38,5 +38,5 @@
         structure = parseresultsfromdisk(md, filename, not md.settings.io_gather)
         if not structure:
-            raise RuntimeError("No result found in binary file '{}'. Check for solution crash.".format(filename))
+            raise RuntimeError('No result found in binary file \'{}\'. Check for solution crash.'.format(filename))
         if not hasattr(structure[0], 'SolutionType'):
             if hasattr(structure[-1], 'SolutionType'):
@@ -64,5 +64,5 @@
 
         if getattr(md.results, structure[0].SolutionType)[0].errlog:
-            print("loadresultsfromdisk info message: error during solution. Check your errlog and outlog model fields.")
+            print('loadresultsfromdisk info message: error during solution. Check your errlog and outlog model fields.')
 
         # If only one solution, extract it from list for user friendliness
